<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "partner_site_entity_event".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PartnerSiteEntityEvent".
 *
 * Columns in table "partner_site_entity_event" available as properties of the model,
 * followed by relations of table "partner_site_entity_event" available as properties of the model.
 *
 * @property integer $id
 * @property integer $partner_site_entity_id
 * @property integer $sort_order
 * @property string $model
 * @property string $event
 * @property string $command
 * @property string $query
 * @property integer $partner_site_entity_event_condition_id
 *
 * @property PartnerSiteEntity $partnerSiteEntity
 * @property PartnerSiteEntityEventCondition $partnerSiteEntityEventCondition
 */
abstract class BasePartnerSiteEntityEvent extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'partner_site_entity_event';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PartnerSiteEntityEvent|PartnerSiteEntityEvents', $n);
    }

    public static function representingColumn()
    {
        return 'model';
    }

    public function rules()
    {
        return array(
            array('model', 'required'),
            array('partner_site_entity_id, sort_order, partner_site_entity_event_condition_id', 'numerical',
                'integerOnly' => true),
            array('model', 'length', 'max' => 255),
            array('event, command', 'length', 'max' => 6),
            array('query', 'safe'),
            array('partner_site_entity_id, sort_order, event, command, query, partner_site_entity_event_condition_id',
                'default', 'setOnEmpty' => true, 'value' => null),
            array('id, partner_site_entity_id, sort_order, model, event, command, query, '
                . 'partner_site_entity_event_condition_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'partnerSiteEntity' => array(self::BELONGS_TO, 'PartnerSiteEntity', 'partner_site_entity_id'),
            'partnerSiteEntityEventCondition' => array(self::BELONGS_TO, 'PartnerSiteEntityEventCondition',
                'partner_site_entity_event_condition_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'partner_site_entity_id' => null,
            'sort_order' => Yii::t('app', 'Sort Order'),
            'model' => Yii::t('app', 'Model'),
            'event' => Yii::t('app', 'Event'),
            'command' => Yii::t('app', 'Command'),
            'query' => Yii::t('app', 'Query'),
            'partner_site_entity_event_condition_id' => null,
            'partnerSiteEntity' => null,
            'partnerSiteEntityEventCondition' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('partner_site_entity_id', $this->partner_site_entity_id);
        $criteria->compare('sort_order', $this->sort_order);
        $criteria->compare('model', $this->model, true);
        $criteria->compare('event', $this->event, true);
        $criteria->compare('command', $this->command, true);
        $criteria->compare('query', $this->query, true);
        $criteria->compare('partner_site_entity_event_condition_id', $this->partner_site_entity_event_condition_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
